package weaver.interfaces.newwaymask.action;

import com.engine.newwaymask.entity.StaffDutyResult;
import com.engine.newwaymask.service.impl.StaffDutyServiceImpl;
import com.weaver.general.Util;
import weaver.conn.RecordSet;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

/**
 * @Author liang.cheng
 * @Date 2025/4/1 11:48
 * @Description: 流程更新编制信息（归档）
 * @Version 1.0
 */
public class StaffByEndWorkflowAction implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {

        String requestid = requestInfo.getRequestid();
        int formid = Math.abs(requestInfo.getRequestManager().getFormid());
        RecordSet rs = new RecordSet();
        String mainTable = String.format("%s%s", "formtable_main_", formid);
        rs.executeQuery("select bzlx from "+mainTable+" where requestid = ?",requestid);
        rs.next();
        int bzlx = Util.getIntValue(rs.getString("bzlx"));
        StaffDutyServiceImpl staffDutyService = new StaffDutyServiceImpl();
        StaffDutyResult result = new StaffDutyResult();
        switch(bzlx) {
            case 0:
                result = staffDutyService.entryWorkflow(requestid, "");
                break;
            case 1:
                result = staffDutyService.transferWorkflow(requestid, "");
                break;
            case 2:
                result = staffDutyService.leaveWorkflow(requestid, "");
                break;
            default:
                result.setStatus(false);
                result.setMessage("流程表单未配置编制类型字段,分类无法匹配");
                break;
        }


        if (result.getStatus()) {
            requestInfo.getRequestManager().setMessagecontent(result.getMessage());
            return Action.SUCCESS;
        }else  {
            requestInfo.getRequestManager().setMessagecontent(result.getMessage());
            return Action.FAILURE_AND_CONTINUE;
        }
    }
}
